package com.sa.ibiz.demo.demo.mapper;

import java.util.List;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import com.sa.ibiz.demo.demo.domain.Org;
import com.sa.ibiz.demo.demo.service.dto.OrgSearchFilter;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
public interface OrgMapper extends BaseMapper<Org>{
    @CacheEvict( value="entity",key = "'Org:'+#p0.orgid")
    void updateOne(@Param("org") Org org);
    List<Org> searchCurChild(@Param("srf") OrgSearchFilter searchfilter,@Param("ew") Wrapper<Org> wrapper) ;
    Page<Org> searchCurChild(IPage page, @Param("srf") OrgSearchFilter searchfilter, @Param("ew") Wrapper<Org> wrapper) ;
    List<Org> searchDefault(@Param("srf") OrgSearchFilter searchfilter,@Param("ew") Wrapper<Org> wrapper) ;
    Page<Org> searchDefault(IPage page, @Param("srf") OrgSearchFilter searchfilter, @Param("ew") Wrapper<Org> wrapper) ;
    List<Org> searchCurCat(@Param("srf") OrgSearchFilter searchfilter,@Param("ew") Wrapper<Org> wrapper) ;
    Page<Org> searchCurCat(IPage page, @Param("srf") OrgSearchFilter searchfilter, @Param("ew") Wrapper<Org> wrapper) ;
    List<Org> searchAllRoot(@Param("srf") OrgSearchFilter searchfilter,@Param("ew") Wrapper<Org> wrapper) ;
    Page<Org> searchAllRoot(IPage page, @Param("srf") OrgSearchFilter searchfilter, @Param("ew") Wrapper<Org> wrapper) ;
    @Select("${sql}")
    List<Map<String,Object>> selectRow( @Param("sql")String sql);
    @Override
    @Cacheable( value="entity",key = "'Org:'+#p0")
    Org selectById(Serializable id);
    @Override
    @CacheEvict( value="entity",key = "'Org:'+#p0.orgid")
    int updateById(@Param(Constants.ENTITY) Org entity);
    @Override
    @CacheEvict( value="entity",key = "'Org:'+#p0.orgid")
    int insert(Org entity);
    @Override
    @CacheEvict( value="entity",key = "'Org:'+#p0")
    int deleteById(Serializable id);
}